/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         arki_reftimeparse
#define yylex           arki_reftimelex
#define yyerror         arki_reftimeerror
#define yydebug         arki_reftimedebug
#define yynerrs         arki_reftimenerrs

/* First part of user prologue.  */
#line 1 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"

#include "config.h"
#include "arki/matcher/reftime/parser.h"
#include "arki/matcher/reftime/lexer.h"
#include "arki/core/fuzzytime.h"
#include <string>
#include <stdexcept>
#include <ctime>
#include <sstream>

using namespace arki::matcher::reftime;
using arki::matcher::reftime::lexer::LexInterval;

// #pragma GCC diagnostic ignored "-Wimplicit-fallthrough"

#include "reftime-parse.hh"
#include "reftime-lex.h"

//#define YYDEBUG 1

// #define DEBUG_PARSER

#ifdef DEBUG_PARSER
#include <stdio.h>

void pdate(const char* msg, const arki::core::FuzzyTime& date)
{
    fprintf(stderr, "%s: %s\n", msg, date.to_string().c_str());
}

void pdate(const char* msg, const int* date)
{
    fprintf(stderr, "%s: %04d-%02d-%02d %02d:%02d:%02d\n", msg, date[0], date[1], date[2], date[3], date[4], date[5]);
}
#else
#define pdate(msg, date) do {} while(0)
#endif

static void arki_reftimeerror(yyscan_t yyscanner, arki::matcher::reftime::Parser& state, const char* s);

static inline void interval_copy(int* dst, const int* src)
{
    for (unsigned i = 0; i < 6; ++i)
       dst[i] = src[i];
}

static inline void init_interval(int* dst, const LexInterval& interval)
{
    for (int i = 0; i < 6; ++i)
        if (i == interval.idx)
            dst[i] = interval.val;
        else
            dst[i] = 0;
}

// Compute where the 0s begin
static unsigned interval_depth(const int* val)
{
    unsigned depth = 0;
    for (unsigned i = 0; i < 6; ++i)
        if (val[i])
            depth = i + 1;
    return depth;
}

// Compute where the -1s begin
static unsigned interval_depth(const arki::core::FuzzyTime& t)
{
    unsigned depth = 0;
    if (t.ye != -1) depth = 1;
    if (t.mo != -1) depth = 2;
    if (t.da != -1) depth = 3;
    if (t.ho != -1) depth = 4;
    if (t.mi != -1) depth = 5;
    if (t.se != -1) depth = 6;
    return depth;
}

static void interval_add(arki::core::FuzzyTime& dst, const int* val, bool subtract=false)
{
    pdate("add", val);
    pdate(" add to", dst);

    // Compute what's the last valid item between dst and val
    unsigned depth = std::max(interval_depth(val), interval_depth(dst));

    // Lowerbound dst, adding val values to it
    arki::core::Time lb = dst.lowerbound();
    if (subtract)
    {
        lb.ye -= val[0];
        lb.mo -= val[1];
        lb.da -= val[2];
        lb.ho -= val[3];
        lb.mi -= val[4];
        lb.se -= val[5];
    } else {
        lb.ye += val[0];
        lb.mo += val[1];
        lb.da += val[2];
        lb.ho += val[3];
        lb.mi += val[4];
        lb.se += val[5];
    }
    pdate(" added", dst);

    // Normalise
    lb.normalise();
    dst = lb;
    pdate(" normalised", dst);

    // Restore all the values not defined in dst and val to -1
    switch (depth)
    {
        case 0: dst.ye = -1; // Falls through
        case 1: dst.mo = -1; // Falls through
        case 2: dst.da = -1; // Falls through
        case 3: dst.ho = -1; // Falls through
        case 4: dst.mi = -1; // Falls through
        case 5: dst.se = -1;
    }
    pdate(" readded missing", dst);
}

void interval_sub(arki::core::FuzzyTime& dst, const int* val)
{
    interval_add(dst, val, true);
}

// Set dst to 'val' before 'now'
arki::core::FuzzyTime* interval_ago(const int* val, time_t now)
{
    struct tm v;
    gmtime_r(&now, &v);
    std::unique_ptr<arki::core::FuzzyTime> res(new arki::core::FuzzyTime(v));
    interval_sub(*res, val);

    // Compute how many nonzero items we have
    unsigned depth = interval_depth(val);

    // Set all the elements after the position of the last nonzero item to -1
    switch (depth)
    {
        case 0: res->ye = -1; // Falls through
        case 1: res->mo = -1; // Falls through
        case 2: res->da = -1; // Falls through
        case 3: res->ho = -1; // Falls through
        case 4: res->mi = -1; // Falls through
        case 5: res->se = -1;
    }

    return res.release();
}

static void mergetime(arki::core::FuzzyTime& dt, const int* time)
{
    dt.mo = dt.mo != -1 ? dt.mo : 1;
    dt.da = dt.da != -1 ? dt.da : 1;
    dt.ho = time[0];
    dt.mi = time[1];
    dt.se = time[2];
}


#line 241 "reftime-parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "reftime-parse.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_DATE = 3,                       /* DATE  */
  YYSYMBOL_TIME = 4,                       /* TIME  */
  YYSYMBOL_TIMEBASE = 5,                   /* TIMEBASE  */
  YYSYMBOL_INTERVAL = 6,                   /* INTERVAL  */
  YYSYMBOL_STEP = 7,                       /* STEP  */
  YYSYMBOL_UNEXPECTED = 8,                 /* UNEXPECTED  */
  YYSYMBOL_NOW = 9,                        /* NOW  */
  YYSYMBOL_TODAY = 10,                     /* TODAY  */
  YYSYMBOL_YESTERDAY = 11,                 /* YESTERDAY  */
  YYSYMBOL_TOMORROW = 12,                  /* TOMORROW  */
  YYSYMBOL_AGO = 13,                       /* AGO  */
  YYSYMBOL_BEFORE = 14,                    /* BEFORE  */
  YYSYMBOL_AFTER = 15,                     /* AFTER  */
  YYSYMBOL_AND = 16,                       /* AND  */
  YYSYMBOL_PLUS = 17,                      /* PLUS  */
  YYSYMBOL_MINUS = 18,                     /* MINUS  */
  YYSYMBOL_MIDDAY = 19,                    /* MIDDAY  */
  YYSYMBOL_NOON = 20,                      /* NOON  */
  YYSYMBOL_MIDNIGHT = 21,                  /* MIDNIGHT  */
  YYSYMBOL_GE = 22,                        /* GE  */
  YYSYMBOL_GT = 23,                        /* GT  */
  YYSYMBOL_LE = 24,                        /* LE  */
  YYSYMBOL_LT = 25,                        /* LT  */
  YYSYMBOL_EQ = 26,                        /* EQ  */
  YYSYMBOL_COMMA = 27,                     /* COMMA  */
  YYSYMBOL_YYACCEPT = 28,                  /* $accept  */
  YYSYMBOL_Input = 29,                     /* Input  */
  YYSYMBOL_Comma = 30,                     /* Comma  */
  YYSYMBOL_Step = 31,                      /* Step  */
  YYSYMBOL_Unexpected = 32,                /* Unexpected  */
  YYSYMBOL_DateExpr = 33,                  /* DateExpr  */
  YYSYMBOL_TimeExpr = 34,                  /* TimeExpr  */
  YYSYMBOL_Interval = 35,                  /* Interval  */
  YYSYMBOL_Absolute = 36,                  /* Absolute  */
  YYSYMBOL_Date = 37,                      /* Date  */
  YYSYMBOL_Daytime = 38                    /* Daytime  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  38
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   65

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  28
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  11
/* YYNRULES -- Number of rules.  */
#define YYNRULES  42
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  58

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   282


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   199,   199,   200,   201,   202,   203,   204,   205,   215,
     218,   219,   223,   224,   228,   229,   230,   231,   232,   235,
     236,   237,   238,   239,   242,   243,   244,   247,   248,   249,
     250,   251,   252,   253,   254,   257,   258,   259,   260,   263,
     264,   265,   266
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "DATE", "TIME",
  "TIMEBASE", "INTERVAL", "STEP", "UNEXPECTED", "NOW", "TODAY",
  "YESTERDAY", "TOMORROW", "AGO", "BEFORE", "AFTER", "AND", "PLUS",
  "MINUS", "MIDDAY", "NOON", "MIDNIGHT", "GE", "GT", "LE", "LT", "EQ",
  "COMMA", "$accept", "Input", "Comma", "Step", "Unexpected", "DateExpr",
  "TimeExpr", "Interval", "Absolute", "Date", "Daytime", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-6)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
      10,     2,    11,    -6,    34,    34,    34,    34,    34,     4,
      -6,     9,     9,    -6,    19,    -6,    -6,    -6,    -6,    -6,
      -6,    -6,    -6,    -6,    -6,    -6,     6,    12,     5,    -6,
      12,    -6,    12,    -6,    12,    -6,    12,    -6,    -6,    -6,
      10,    -6,    -6,    -6,    -6,    -6,    53,    53,    33,    43,
      43,    -6,    25,    12,    12,    -6,     7,     7
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,     0,     0,    10,     0,     0,     0,     0,     0,     0,
       6,     2,     4,    12,     8,    11,    38,    42,    24,    27,
      35,    36,    37,    39,    40,    41,     0,    14,    28,    19,
      15,    20,    16,    21,    17,    22,    18,    23,     1,     9,
       0,     3,     5,    13,    25,    30,     0,     0,     0,     0,
       0,    29,     7,    31,    32,    26,    33,    34
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
      -6,    17,    -6,    36,    -6,    -6,    -6,     1,    -5,    -6,
       0
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     9,    40,    10,    14,    11,    12,    26,    27,    28,
      29
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      30,    32,    34,    36,    38,    31,    33,    35,    37,    17,
      13,     1,    44,    44,     2,     2,     3,     3,    15,    45,
      46,    47,    48,    48,    23,    24,    25,    43,    51,    49,
      50,    39,     4,     5,     6,     7,     8,    16,    17,    55,
      18,    53,    54,    19,    20,    21,    22,    41,    42,    18,
      56,    57,    39,    23,    24,    25,    16,    52,     0,    18,
       0,     0,    19,    20,    21,    22
};

static const yytype_int8 yycheck[] =
{
       5,     6,     7,     8,     0,     5,     6,     7,     8,     4,
       8,     1,     6,     6,     5,     5,     7,     7,     7,    13,
      14,    15,    16,    16,    19,    20,    21,     8,    28,    17,
      18,    27,    22,    23,    24,    25,    26,     3,     4,     6,
       6,    46,    47,     9,    10,    11,    12,    11,    12,     6,
      49,    50,    27,    19,    20,    21,     3,    40,    -1,     6,
      -1,    -1,     9,    10,    11,    12
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     1,     5,     7,    22,    23,    24,    25,    26,    29,
      31,    33,    34,     8,    32,     7,     3,     4,     6,     9,
      10,    11,    12,    19,    20,    21,    35,    36,    37,    38,
      36,    38,    36,    38,    36,    38,    36,    38,     0,    27,
      30,    31,    31,     8,     6,    13,    14,    15,    16,    17,
      18,    38,    29,    36,    36,     6,    35,    35
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    28,    29,    29,    29,    29,    29,    29,    29,    30,
      31,    31,    32,    32,    33,    33,    33,    33,    33,    34,
      34,    34,    34,    34,    35,    35,    35,    36,    36,    36,
      36,    36,    36,    36,    36,    37,    37,    37,    37,    38,
      38,    38,    38
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     3,     2,     1,
       1,     2,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     2,     3,     1,     1,     2,
       2,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (yyscanner, state, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, yyscanner, state); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, void* yyscanner, arki::matcher::reftime::Parser& state)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yyscanner);
  YY_USE (state);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, void* yyscanner, arki::matcher::reftime::Parser& state)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, yyscanner, state);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, void* yyscanner, arki::matcher::reftime::Parser& state)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], yyscanner, state);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, yyscanner, state); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, void* yyscanner, arki::matcher::reftime::Parser& state)
{
  YY_USE (yyvaluep);
  YY_USE (yyscanner);
  YY_USE (state);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (void* yyscanner, arki::matcher::reftime::Parser& state)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Input: DateExpr  */
#line 199 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { state.add((yyvsp[0].dtmatch)); }
#line 1310 "reftime-parse.cc"
    break;

  case 3: /* Input: DateExpr Step  */
#line 200 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { state.add((yyvsp[-1].dtmatch)); state.add((yyvsp[0].dtmatch)); }
#line 1316 "reftime-parse.cc"
    break;

  case 4: /* Input: TimeExpr  */
#line 201 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { state.add((yyvsp[0].dtmatch)); }
#line 1322 "reftime-parse.cc"
    break;

  case 5: /* Input: TimeExpr Step  */
#line 202 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { state.add((yyvsp[-1].dtmatch)); state.add((yyvsp[0].dtmatch)); }
#line 1328 "reftime-parse.cc"
    break;

  case 6: /* Input: Step  */
#line 203 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { state.add((yyvsp[0].dtmatch)); }
#line 1334 "reftime-parse.cc"
    break;

  case 7: /* Input: Input Comma Input  */
#line 204 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            {}
#line 1340 "reftime-parse.cc"
    break;

  case 8: /* Input: error Unexpected  */
#line 205 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            {
                                std::string msg = "before '";
                                msg += state.unexpected;
                                msg += "'";
                                arki_reftimeerror(yyscanner, state, msg.c_str());
                                yyclearin;
                                YYERROR;
                            }
#line 1353 "reftime-parse.cc"
    break;

  case 9: /* Comma: COMMA  */
#line 215 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { state.timebase = -1; }
#line 1359 "reftime-parse.cc"
    break;

  case 10: /* Step: STEP  */
#line 218 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createStep((yyvsp[0].lexInterval).val, (yyvsp[0].lexInterval).idx); }
#line 1365 "reftime-parse.cc"
    break;

  case 11: /* Step: TIMEBASE STEP  */
#line 219 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createStep((yyvsp[0].lexInterval).val, (yyvsp[0].lexInterval).idx, (yyvsp[-1].tspec)); }
#line 1371 "reftime-parse.cc"
    break;

  case 12: /* Unexpected: UNEXPECTED  */
#line 223 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { state.unexpected = std::string() + (yyvsp[0].error); }
#line 1377 "reftime-parse.cc"
    break;

  case 13: /* Unexpected: Unexpected UNEXPECTED  */
#line 225 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { state.unexpected += (yyvsp[0].error); }
#line 1383 "reftime-parse.cc"
    break;

  case 14: /* DateExpr: GE Absolute  */
#line 228 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createGE((yyvsp[0].dtspec)); }
#line 1389 "reftime-parse.cc"
    break;

  case 15: /* DateExpr: GT Absolute  */
#line 229 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createGT((yyvsp[0].dtspec)); }
#line 1395 "reftime-parse.cc"
    break;

  case 16: /* DateExpr: LE Absolute  */
#line 230 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createLE((yyvsp[0].dtspec)); }
#line 1401 "reftime-parse.cc"
    break;

  case 17: /* DateExpr: LT Absolute  */
#line 231 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createLT((yyvsp[0].dtspec)); }
#line 1407 "reftime-parse.cc"
    break;

  case 18: /* DateExpr: EQ Absolute  */
#line 232 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createEQ((yyvsp[0].dtspec)); }
#line 1413 "reftime-parse.cc"
    break;

  case 19: /* TimeExpr: GE Daytime  */
#line 235 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createTimeGE((yyvsp[0].tspec)); }
#line 1419 "reftime-parse.cc"
    break;

  case 20: /* TimeExpr: GT Daytime  */
#line 236 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createTimeGT((yyvsp[0].tspec)); }
#line 1425 "reftime-parse.cc"
    break;

  case 21: /* TimeExpr: LE Daytime  */
#line 237 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createTimeLE((yyvsp[0].tspec)); }
#line 1431 "reftime-parse.cc"
    break;

  case 22: /* TimeExpr: LT Daytime  */
#line 238 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createTimeLT((yyvsp[0].tspec)); }
#line 1437 "reftime-parse.cc"
    break;

  case 23: /* TimeExpr: EQ Daytime  */
#line 239 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                            { (yyval.dtmatch) = state.createTimeEQ((yyvsp[0].tspec)); }
#line 1443 "reftime-parse.cc"
    break;

  case 24: /* Interval: INTERVAL  */
#line 242 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { init_interval((yyval.interval), (yyvsp[0].lexInterval)); }
#line 1449 "reftime-parse.cc"
    break;

  case 25: /* Interval: Interval INTERVAL  */
#line 243 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { interval_copy((yyval.interval), (yyvsp[-1].interval)); (yyvsp[0].lexInterval).add_to((yyval.interval)); }
#line 1455 "reftime-parse.cc"
    break;

  case 26: /* Interval: Interval AND INTERVAL  */
#line 244 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { interval_copy((yyval.interval), (yyvsp[-2].interval)); (yyvsp[0].lexInterval).add_to((yyval.interval)); }
#line 1461 "reftime-parse.cc"
    break;

  case 27: /* Absolute: NOW  */
#line 247 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = state.mknow(); }
#line 1467 "reftime-parse.cc"
    break;

  case 28: /* Absolute: Date  */
#line 248 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = (yyvsp[0].dtspec); }
#line 1473 "reftime-parse.cc"
    break;

  case 29: /* Absolute: Date Daytime  */
#line 249 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = (yyvsp[-1].dtspec); mergetime(*(yyval.dtspec), (yyvsp[0].tspec)); }
#line 1479 "reftime-parse.cc"
    break;

  case 30: /* Absolute: Interval AGO  */
#line 250 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = interval_ago((yyvsp[-1].interval), state.tnow); }
#line 1485 "reftime-parse.cc"
    break;

  case 31: /* Absolute: Interval BEFORE Absolute  */
#line 251 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = (yyvsp[0].dtspec); interval_sub(*(yyval.dtspec), (yyvsp[-2].interval)); }
#line 1491 "reftime-parse.cc"
    break;

  case 32: /* Absolute: Interval AFTER Absolute  */
#line 252 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = (yyvsp[0].dtspec); interval_add(*(yyval.dtspec), (yyvsp[-2].interval)); }
#line 1497 "reftime-parse.cc"
    break;

  case 33: /* Absolute: Absolute PLUS Interval  */
#line 253 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = (yyvsp[-2].dtspec); interval_add(*(yyval.dtspec), (yyvsp[0].interval)); }
#line 1503 "reftime-parse.cc"
    break;

  case 34: /* Absolute: Absolute MINUS Interval  */
#line 254 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = (yyvsp[-2].dtspec); interval_sub(*(yyval.dtspec), (yyvsp[0].interval)); }
#line 1509 "reftime-parse.cc"
    break;

  case 35: /* Date: TODAY  */
#line 257 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = state.mktoday(); }
#line 1515 "reftime-parse.cc"
    break;

  case 36: /* Date: YESTERDAY  */
#line 258 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = state.mkyesterday(); }
#line 1521 "reftime-parse.cc"
    break;

  case 37: /* Date: TOMORROW  */
#line 259 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.dtspec) = state.mktomorrow(); }
#line 1527 "reftime-parse.cc"
    break;

  case 38: /* Date: DATE  */
#line 260 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { }
#line 1533 "reftime-parse.cc"
    break;

  case 39: /* Daytime: MIDDAY  */
#line 263 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.tspec)[0] = 12; (yyval.tspec)[1] = 0; (yyval.tspec)[2] = 0; }
#line 1539 "reftime-parse.cc"
    break;

  case 40: /* Daytime: NOON  */
#line 264 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.tspec)[0] = 12; (yyval.tspec)[1] = 0; (yyval.tspec)[2] = 0; }
#line 1545 "reftime-parse.cc"
    break;

  case 41: /* Daytime: MIDNIGHT  */
#line 265 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { (yyval.tspec)[0] = 0; (yyval.tspec)[1] = 0; (yyval.tspec)[2] = 0; }
#line 1551 "reftime-parse.cc"
    break;

  case 42: /* Daytime: TIME  */
#line 266 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"
                                        { }
#line 1557 "reftime-parse.cc"
    break;


#line 1561 "reftime-parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (yyscanner, state, YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, yyscanner, state);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yyscanner, state);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (yyscanner, state, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, yyscanner, state);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yyscanner, state);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 269 "/builddir/build/BUILD/arkimet-1.45-1/arki/matcher/reftime/reftime-parse.yy"


void arki_reftimeerror(yyscan_t yyscanner, arki::matcher::reftime::Parser& state, const char* s)
{
    state.errors.push_back(s);
    //tagcoll::TagexprParser::instance()->addError(s);
    //fprintf(stderr, "%s\n", s);
}

namespace arki {
namespace matcher {
namespace reftime {

void Parser::parse(const std::string& str)
{
    for (auto& i: res)
        delete i;
    errors.clear();
    res.clear();
    timebase = -1;

    yyscan_t scanner;
    arki_reftimelex_init(&scanner);

    YY_BUFFER_STATE buf = arki_reftime_scan_string(str.c_str(), scanner);

    int res = yyparse(scanner, *this);
    arki_reftime_delete_buffer(buf, scanner);
    arki_reftimelex_destroy(scanner);

    switch (res)
    {
        case 0:
            // Parse successful
            break;
        case 1: {
            // Syntax error
            std::stringstream ss;
            ss << "cannot parse '" << str << "': ";
            for (std::vector<std::string>::const_iterator i = errors.begin();
                    i != errors.end(); ++i)
            {
                if (i != errors.begin())
                    ss << "; ";
                ss << *i;
            }
            throw std::invalid_argument(ss.str());
        }
        case 2:
            // Out of memory
            throw std::runtime_error("parser out of memory");
        default: {
            // Should never happen
            std::stringstream ss;
            ss << "cannot parse '" << str << "': Bison parser function returned unexpected value " << res;
            throw std::runtime_error(ss.str());
        }
    }
}

}
}
}
